#ifndef STATE_HPP
#define STATE_HPP

#include "godot_cpp/core/defs.hpp"
#include <godot_cpp/classes/node.hpp>

namespace godot {
class StateMachine;

class IState {
    friend class StateMachine;
public:
    virtual void init(Node *target, StateMachine *machine) = 0;
    virtual StringName get_next() const = 0;
    _ALWAYS_INLINE_ Node *as_node() { return dynamic_cast<Node*>(this); }
};
}

#endif // !STATE_HPP
